﻿import caurina.transitions.Tweener;

class Card extends MovieClip {
	var txt:String;
	var wid:Number;
	var my_txt:TextField;
	var my_fmt:TextFormat;
	var my_x;
	var type:String;
	function Card(){
		my_fmt = new TextFormat();
		my_fmt.font = "_sans";
		my_fmt.align = "center";
		my_fmt.size = 24;
		my_txt = this.createTextField("my_txt", this.getNextHighestDepth(), 0, 5, wid, 30);
		my_txt.text = txt;
		my_txt.setTextFormat(my_fmt);
		my_x = _x;
	}
	function onPress():Void {
		var i:Number = (_y/this._parent.h)-1;
		setSlot(i, null);
		this.swapDepths(this._parent.topCard);
		this._parent.topCard = this;
		this.startDrag(false, _x, this._parent.h, _x, (this._parent.rows+1)*this._parent.h);
	}
	function onReleaseOutside():Void {
		onRelease();
	}
	function onRelease():Void {
		this.stopDrag();
		stopEverything();
		var i:Number = Math.round(_y/this._parent.h)-1;
		var delay:Number = 0;
		if (getSlot(i) != null) {
		// find nearest empty slot for the card
			var j, gap1, gap2, gap, step:Number;
			for (j = 0; j < this._parent.rows+1; j++)
				if (getSlot(j) == null) {
					gap1 = j;
					break;
				}
			for (j++; j < this._parent.rows+1; j++)
			 	if (getSlot(j) == null) {
					gap2 = j;
					break;
				}
			//trace("gap1:"+gap1+",gap2:"+gap2);
			if (Math.abs(gap1 - ((_y/this._parent.h)-1)) <= Math.abs(gap2 - ((_y/this._parent.h)-1)))
				gap = gap1;
			else
				gap = gap2;
			step = (gap < i) ? 1 : -1;
			//trace("card at "+i+", moving to fill up gap at "+gap);
			for (j = gap; j != i; j += step) {
				var c:Card = getSlot(j+step);
				setSlot(j, c);
				Tweener.addTween(c, {_y:this._parent.h*(j+1), time:0.1, delay:delay, transition:"easeInOutQuad"});
				delay += 0.1;
			}
		}
		setSlot(i, this);
		Tweener.addTween(this, {_y:this._parent.h*(i+1), time:0.1, delay:delay, transition:"easeInOutQuad", 
						 		onComplete:finished});
		this._parent["my_txt"]._visible = false;
	}
	function stopEverything() {
		for (var i:Number = 0; i < this._parent.rows; i++)
		{
			this._parent.cards[i][0].enabled = false;
			this._parent.cards[i][1].enabled = false;
			this._parent.cards[i][2].enabled = false;
		}
	}
	function finished() {
		for (var i:Number = 0; i < this._parent.rows; i++)
		{
			this._parent.cards[i][0].enabled = true;
			this._parent.cards[i][1].enabled = true;
			this._parent.cards[i][2].enabled = true;
		}
	}
	function getCol():Number {
		if (type == "object")
			return 0;
		else if (type == "value")
			return 1;
		else if (type == "unit")
			return 2;
	}
	function getSlot(i:Number):Card {
			return this._parent.slots[getCol()][i].card;
	}
	function setSlot(i:Number, c:Card) {
		this._parent.slots[getCol()][i].card = c;
	}
}